{ pkgs
, nixpkgs
, home-manager
, system
, mkSysRole
, mkUser
, ...
}:

{
  mkHost = { name, users, roles ? [ ], imports ? [ ] }:
    let
      users_mod = (map
        (u:
          mkUser {
            name = u.user;
            roles = u.roles;
          })
        users);
      roles_mod = (map (r: mkSysRole r) roles);
      add_imports = imports;
    in
    nixpkgs.lib.nixosSystem {
      inherit system pkgs;

      modules = [
        {
          imports = users_mod ++
            roles_mod ++
            add_imports ++ [
            (mkSysRole "common")
            (mkSysRole "acme")
            (mkUser { name = "root"; roles = [ ]; })
          ];

          home-manager = {
            useGlobalPkgs = true;
          };

          system.stateVersion = "24.05";
        }

        home-manager.nixosModules.home-manager
        ../hosts/${name}/default.nix
      ];
    };
}
